package com.mdd.admin.service.impl;

import com.mdd.admin.service.IChannelOaConfigService;
import com.mdd.admin.validate.channel.ChannelOaValidate;
import com.mdd.admin.vo.channel.ChannelOaVo;
import com.mdd.common.util.ConfigUtils;
import com.mdd.common.util.RequestUtils;
import com.mdd.common.util.StringUtils;
import com.mdd.common.util.UrlUtils;
import com.mdd.common.util.YmlUtils;
import java.util.Map;
import org.springframework.stereotype.Service;

@Service
public class ChannelOaConfigServiceImpl implements IChannelOaConfigService {
   public ChannelOaVo detail() {
      Map<String, String> config = ConfigUtils.get("oa_channel");
      ChannelOaVo vo = new ChannelOaVo();
      String env = YmlUtils.get("like.production");
      boolean envStatus = StringUtils.isNotNull(env) && env.equals("true");
      vo.setQrCode(UrlUtils.toAbsoluteUrl((String)config.getOrDefault("qrCode", "")));
      vo.setName((String)config.getOrDefault("name", ""));
      vo.setPrimaryId((String)config.getOrDefault("primaryId", ""));
      vo.setAppId(envStatus ? "******" : (String)config.getOrDefault("appId", ""));
      vo.setAppSecret(envStatus ? "******" : (String)config.getOrDefault("appSecret", ""));
      vo.setUrl((String)config.getOrDefault("url", ""));
      vo.setToken((String)config.getOrDefault("token", ""));
      vo.setEncodingAesKey((String)config.getOrDefault("encodingAesKey", ""));
      vo.setEncryptionType(Integer.parseInt((String)config.getOrDefault("encryptionType", "1")));
      String domain = RequestUtils.domain();
      vo.setBusinessDomain(domain);
      vo.setJsDomain(domain);
      vo.setWebDomain(domain);
      return vo;
   }

   public void save(ChannelOaValidate channelOaValidate) {
      ConfigUtils.set("oa_channel", "name", channelOaValidate.getName());
      ConfigUtils.set("oa_channel", "primaryId", channelOaValidate.getPrimaryId());
      ConfigUtils.set("oa_channel", "qrCode", UrlUtils.toRelativeUrl(channelOaValidate.getQrCode()));
      ConfigUtils.set("oa_channel", "appId", channelOaValidate.getAppId());
      ConfigUtils.set("oa_channel", "appSecret", channelOaValidate.getAppSecret());
      ConfigUtils.set("oa_channel", "url", channelOaValidate.getUrl());
      ConfigUtils.set("oa_channel", "token", channelOaValidate.getToken());
      ConfigUtils.set("oa_channel", "encodingAesKey", channelOaValidate.getEncodingAesKey());
      ConfigUtils.set("oa_channel", "encryptionType", String.valueOf(channelOaValidate.getEncryptionType()));
   }
}
